precision mediump float;

uniform mediump #INPUT_TYPE u_image;
uniform mat4 u_colorMatrix;
uniform vec4 u_colorOffset;

varying vec2 v_texCoord;

void main() {
    vec4 color = texture2D(u_image, v_texCoord);

    color.rgb /= color.a; // Undo premultiply alpha

    // Apply Color Matrix
    color = clamp(color * u_colorMatrix + u_colorOffset, 0.0, 1.0);

    color.rgb *= color.a; // Do premultiply alpha

    gl_FragColor = color;
}